# -*- coding: utf-8 -*-

import wfdb
import numpy as np
from scipy.signal import medfilt

"""
Written by:  Sen Liu, ya'nan Wang, Haijun Jia
"""


class Preprocessing:

    def __init__(self, fs, data, sample_path):
        self.fs = fs
        self.data = data
        self.sample_path = sample_path

    def data_filter(self):
        """Remove Baseline"""
        baseline = medfilt(self.data, 71)
        baseline = medfilt(baseline, 215)

        for i in range(0, len(self.data)):
            self.data[i] = self.data[i] - baseline[i]
        ecgB = self.data

        return ecgB

    def beatread(self):
        """segment"""
        ann = wfdb.rdann(self.sample_path, 'atr')
        beatPos = ann.__dict__['sample'].tolist()
        beatPos_new = []
        beatList = []
        widForward = round(0.3 * self.fs)
        widBackward = 1 * self.fs - widForward
        beatCnt = 0

        for i in range(len(beatPos)):

            qrsInd = beatPos[i]
            beatStart = qrsInd - widForward
            beatEnd = qrsInd + widBackward

            if (beatStart >= 0) and (beatEnd <= len(self.data) - 1):
                beatPos_new.append(beatPos[i])
                beat = self.data[beatStart:beatEnd]
                beatNorm = (beat - np.min(beat)) / (np.max(beat) - np.min(beat)+0.000001)
                beatList.append(beatNorm)

            beatCnt = beatCnt + 1

        return beatList, beatPos_new, beatPos
